ToggleWindow = class( Turbine.UI.Window );

function ToggleWindow:Constructor()
	Turbine.UI.Window.Constructor( self );
	
	-- legacy fix
	if not (Settings.ToggleVisible) then
		Settings.ToggleVisible = "yes";		
		Settings.ToggleLeft = tostring(Turbine.UI.Display.GetWidth()-55);
		Settings.ToggleTop = "270";
	end	
	
	self:SetPosition( Settings.ToggleLeft, Settings.ToggleTop );
	self:SetSize(35,35);
	self:SetZOrder(70);	
	self:SetVisible( true );
	
	self.button = Turbine.UI.Control();
	self.button:SetParent(self);
	self.button:SetPosition(0,0);
	self.button:SetSize(35,35);
	self.button:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.button:SetBackground("Chiran/Lotropad/toggle.tga");
	self.button.MouseEnter = function(sender,args)
		self.button:SetBackground("Chiran/Lotropad/toggle_hover.tga");
	end
	self.button.MouseLeave = function(sender,args)
		self.button:SetBackground("Chiran/Lotropad/toggle.tga");
	end		
	self.button.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			if not self.button:IsShiftKeyDown() then
				lotropadWindow:SetVisible( not lotropadWindow:IsVisible() );
			else
				self:SetBackColor( Turbine.UI.Color(1,0,1,0) );
				sender.dragStartX = args.X;
				sender.dragStartY = args.Y;
				sender.dragging = true;
			end
		end
	end
	self.button.MouseUp = function( sender, args ) 
		if (args.Button == Turbine.UI.MouseButton.Left) then
			if (sender.dragging) then 
				sender.dragging = false;
				Settings.ToggleTop = self:GetTop();
				Settings.ToggleLeft = self:GetLeft();
				self:SetBackColor( Turbine.UI.Color(0,0,0,0) );
			end
		end
	end
	self.button.MouseMove = function(sender,args)
		if self.button:IsShiftKeyDown() then
			local left, top = self:GetPosition();
				
			if ( sender.dragging ) then
				self:SetPosition( left + ( args.X - sender.dragStartX ), top + args.Y - sender.dragStartY );
			end
			sender:SetPosition( 0, 0 );
		end
	end
end
